Index: /branches/OMEdit/OMEditGUI/ModelWidgetContainer.cpp
===================================================================
--- /branches/OMEdit/OMEditGUI/ModelWidgetContainer.cpp	(revision 13536)
+++ /branches/OMEdit/OMEditGUI/ModelWidgetContainer.cpp	(revision 13537)
@@ -133,17 +133,6 @@
   setIsCreatingConnection(false);
   mIsMovingComponents = false;
-
-
-
-
-  mIsCreatingLine = false;
-  mIsCreatingPolygon = false;
-  mIsCreatingRectangle = false;
-  mIsCreatingEllipse = false;
-  mIsCreatingText = false;
-  mIsCreatingBitmap = false;
   mCustomScale = false;
   createActions();
-  createMenus();
 }
 
@@ -380,6 +369,6 @@
   else
     annotation = pMainWindow->getOMCProxy()->getIconAnnotation(className);
-  Component_OMC *pComponent;
-  pComponent = new Component_OMC(annotation, name, className, type, transformationString, point, pMainWindow->getOMCProxy(), this);
+  Component *pComponent;
+  pComponent = new Component(annotation, name, className, type, transformationString, point, pMainWindow->getOMCProxy(), this);
   // unselect all items
   foreach (QGraphicsItem *pItem, items())
@@ -391,8 +380,8 @@
     addComponentObject(pComponent);
   else
-    mComponents_OMCList.append(pComponent);
-}
-
-void GraphicsView::addComponentObject(Component_OMC *pComponent)
+    mComponentsList.append(pComponent);
+}
+
+void GraphicsView::addComponentObject(Component *pComponent)
 {
   MainWindow *pMainWindow = mpModelWidget->getModelWidgetContainer()->getMainWindow();
@@ -403,60 +392,5 @@
   mpModelWidget->getModelicaTextWidget()->getModelicaTextEdit()->document()->setModified(true);
   // add the component to the local list
-  mComponents_OMCList.append(pComponent);
-}
-
-void GraphicsView::addComponentoView(QString name, QString className, QString transformationString, QPointF point, bool isConnector,
-                                     bool addObject, bool diagram)
-{
-  MainWindow *pMainWindow = mpModelWidget->getModelWidgetContainer()->getMainWindow();
-  // Check if the icon is already loaded.
-  Component *oldComponent = 0;//pMainWindow->getLibraryTreeWidget()->getComponentObject(className);
-  Component *newComponent;
-
-  // if the item is a connector then we need to get the diagram annotation of it
-  if (diagram)
-  {
-    QString result = pMainWindow->getOMCProxy()->getDiagramAnnotation(className);
-    newComponent = new Component(result, name, className, transformationString, point, isConnector, pMainWindow->getOMCProxy(), this);
-  }
-  else
-  {
-    if (!oldComponent)
-    {
-      LibraryComponent *libComponent;
-      QString result = pMainWindow->getOMCProxy()->getIconAnnotation(className);
-      libComponent = new LibraryComponent(result, className, pMainWindow->getOMCProxy());
-      // add the component to library widget components lists
-      pMainWindow->getLibraryTreeWidget()->addLibraryComponentObject(libComponent);
-      // create a new component now.
-      newComponent = new Component(result, name, className, transformationString, point, isConnector, pMainWindow->getOMCProxy(), this);
-    }
-    else
-    {
-      newComponent = new Component(oldComponent, name, transformationString, point, isConnector, this);
-    }
-  }
-  if (addObject)
-    addComponentObject(newComponent);
-  else
-    mComponentsList.append(newComponent);
-}
-
-void GraphicsView::addComponentObject(Component *component)
-{
-  MainWindow *pMainWindow = mpModelWidget->getModelWidgetContainer()->getMainWindow();
-  // Add the component to model in OMC Global Scope.
-  pMainWindow->getOMCProxy()->addComponent(component->getName(), component->getClassName(), mpModelWidget->getLibraryTreeNode()->getNameStructure(), "");
-  // add the annotations of icon
-  if (component->getIsConnector())
-    component->updateAnnotationString(true);
-  else
-    component->updateAnnotationString(false);
-  // only update the modelicatext of model if its a diagram view
-  // for icon view the modeltext is updated in updateannotationstring->addclassannotation
-  if (mViewType == StringHandler::DIAGRAM)
-    mpModelWidget->getModelicaTextWidget()->getModelicaTextEdit()->setPlainText(pMainWindow->getOMCProxy()->list(mpModelWidget->getLibraryTreeNode()->getNameStructure()));
-  // add the component to the local list
-  mComponentsList.append(component);
+  mComponentsList.append(pComponent);
 }
 
@@ -465,5 +399,5 @@
 //! @param update flag is used to check whether we need to update the modelica editor text or not.
 //! @see deleteAllComponentObjects()
-void GraphicsView::deleteComponent_OMCObject(Component_OMC *pComponent)
+void GraphicsView::deleteComponentObject(Component *pComponent)
 {
   // First Remove the Connector associated to this icon
@@ -483,5 +417,5 @@
   }
   // remove the icon now from local list
-  mComponents_OMCList.removeOne(pComponent);
+  mComponentsList.removeOne(pComponent);
   OMCProxy *pOMCProxy = mpModelWidget->getModelWidgetContainer()->getMainWindow()->getOMCProxy();
   // delete the component from OMC
@@ -489,51 +423,7 @@
 }
 
-//! Delete the component and its corresponding connectors from the components list and OMC.
-//! @param component is the object to be deleted.
-//! @param update flag is used to check whether we need to update the modelica editor text or not.
-//! @see deleteAllComponentObjects()
-void GraphicsView::deleteComponentObject(Component *component, bool update)
-{
-  // First Remove the Connector associated to this icon
-  int i = 0;
-  while(i != mConnectorsVector.size())
-  {
-    if((mConnectorsVector[i]->getStartComponent()->getParentComponent()->getName() == component->getName()) or
-       (mConnectorsVector[i]->getEndComponent()->getParentComponent()->getName() == component->getName()))
-    {
-      removeConnector(mConnectorsVector[i], update);
-      i = 0;   //Restart iteration if map has changed
-    }
-    else
-    {
-      ++i;
-    }
-  }
-  // remove the icon now from local list
-  mComponentsList.removeOne(component);
-  OMCProxy *pOMCProxy = mpModelWidget->getModelWidgetContainer()->getMainWindow()->getOMCProxy();
-  // delete the component from OMC
-  pOMCProxy->deleteComponent(component->getName(), mpModelWidget->getLibraryTreeNode()->getNameStructure());
-  if (update)
-  {
-    mpModelWidget->getModelicaTextWidget()->getModelicaTextEdit()->setPlainText(pOMCProxy->list(mpModelWidget->getLibraryTreeNode()->getNameStructure()));
-    //mpModelWidget->getModelWidgetContainer()->getMainWindow()->getModelBrowserTreeWidget()->updateModelBrowserTreeWidget();
-  }
-}
-
-//! Delete all the component and their corresponding connectors from the model.
-//! @see deleteComponentObject(Component *component, bool update)
-void GraphicsView::deleteAllComponentObjects()
-{
-  mComponentsList.clear();
-  //    foreach (Component *component, mComponentsList)
-  //    {
-  //        component->deleteMe(false);
-  //    }
-}
-
-Component_OMC* GraphicsView::getComponent_OMCObject(QString componentName)
-{
-  foreach (Component_OMC *component, mComponents_OMCList)
+Component* GraphicsView::getComponentObject(QString componentName)
+{
+  foreach (Component *component, mComponentsList)
   {
     if (component->getName() == componentName)
@@ -543,19 +433,9 @@
 }
 
-Component* GraphicsView::getComponentObject(QString componentName)
-{
-  foreach (Component *component, mComponentsList)
-  {
-    if (component->getName() == componentName)
-      return component;
-  }
-  return 0;
-}
-
 QString GraphicsView::getUniqueComponentName(QString componentName, int number)
 {
   QString name;
   name = QString(componentName).append(QString::number(number));
-  foreach (Component_OMC *pComponent, mComponents_OMCList)
+  foreach (Component *pComponent, mComponentsList)
   {
     if (pComponent->getName().compare(name, Qt::CaseSensitive) == 0)
@@ -570,5 +450,5 @@
 bool GraphicsView::checkComponentName(QString componentName)
 {
-  foreach (Component_OMC *pComponent, mComponents_OMCList)
+  foreach (Component *pComponent, mComponentsList)
     if (pComponent->getName().compare(componentName, Qt::CaseSensitive) == 0)
       return false;
@@ -576,44 +456,9 @@
 }
 
-void GraphicsView::addShapeObject(ShapeAnnotation *shape)
-{
-  mShapesList.append(shape);
-}
-
-void GraphicsView::deleteShapeObject(ShapeAnnotation *shape)
-{
-  mShapesList.removeOne(shape);
-}
-
-void GraphicsView::deleteAllShapesObject()
-{
-  mShapesList.clear();
-  //    foreach (ShapeAnnotation *shape, mShapesList)
-  //    {
-  //        shape->deleteMe();
-  //    }
-}
-
-void GraphicsView::removeAllConnectors()
-{
-  mConnectorsVector.clear();
-  //    int i = 0;
-  //    while(i != mConnectorsVector.size())
-  //    {
-  //        removeConnector(mConnectorsVector[i], false);
-  //        i = 0;   //Restart iteration if map has changed
-  //    }
-}
-
 //! Defines what happens when the mouse is moving in a GraphicsView.
 //! @param event contains information of the mouse moving operation.
 void GraphicsView::mouseMoveEvent(QMouseEvent *event)
 {
-  // don't send mouse move events to items if we are creating something
-  if (!mIsCreatingLine and !mIsCreatingPolygon and !mIsCreatingRectangle
-      and !mIsCreatingEllipse and !mIsCreatingText and !mIsCreatingBitmap)
-  {
-    QGraphicsView::mouseMoveEvent(event);
-  }
+  QGraphicsView::mouseMoveEvent(event);
   //If creating connector, the end port shall be updated to the mouse position.
   if (isCreatingConnection())
@@ -621,40 +466,4 @@
     mpConnectionLineAnnotation->updateEndPoint(mapToScene(event->pos()));
     mpConnectionLineAnnotation->update();
-  }
-  //If creating line shape, the end points shall be updated to the mouse position.
-  else if (mIsCreatingLine)
-  {
-    mpLineShape->updateEndPoint(mapToScene(event->pos()));
-    mpLineShape->update();
-  }
-  //If creating polygon shape, the end points shall be updated to the mouse position.
-  else if (mIsCreatingPolygon)
-  {
-    mpPolygonShape->updateEndPoint(mapToScene(event->pos()));
-    mpPolygonShape->update();
-  }
-  //If creating rectangle shape, the end points shall be updated to the mouse position.
-  else if (mIsCreatingRectangle)
-  {
-    mpRectangleShape->updateEndPoint(mapToScene(event->pos()));
-    mpRectangleShape->update();
-  }
-  //If creating ellipse shape, the end points shall be updated to the mouse position.
-  else if (mIsCreatingEllipse)
-  {
-    mpEllipseShape->updateEndPoint(mapToScene(event->pos()));
-    mpEllipseShape->update();
-  }
-  //If creating text shape, the end points shall be updated to the mouse position.
-  else if (mIsCreatingText)
-  {
-    mpTextShape->updateEndPoint(mapToScene(event->pos()));
-    mpTextShape->update();
-  }
-  //If creating bitmap shape, the end points shall be updated to the mouse position.
-  else if (mIsCreatingBitmap)
-  {
-    mpBitmapShape->updateEndPoint(mapToScene(event->pos()));
-    mpBitmapShape->update();
   }
 }
@@ -670,40 +479,4 @@
     mpConnectionLineAnnotation->addPoint(mapToScene(event->pos()));
   }
-  // if left button presses and we are starting to create a Line
-  else if ((event->button() == Qt::LeftButton) && pMainWindow->getLineAction()->isChecked())
-  {
-    // if we are starting to create a line then create line object and add to graphicsview
-    createLineShape(mapToScene(event->pos()));
-  }
-  // if left button presses and we are starting to create a Rectangle
-  else if ((event->button() == Qt::LeftButton) && pMainWindow->getRectangleAction()->isChecked())
-  {
-    // if we are starting to create a rectangle then create rectangle object and add to graphicsview
-    createRectangleShape(mapToScene(event->pos()));
-  }
-  // if left button presses and we are starting to create an Ellipse
-  else if ((event->button() == Qt::LeftButton) && pMainWindow->getEllipseAction()->isChecked())
-  {
-    // if we are starting to create a rectangle then create rectangle object and add to graphicsview
-    createEllipseShape(mapToScene(event->pos()));
-  }
-  // if left button presses and we are starting to create a Polygon
-  else if ((event->button() == Qt::LeftButton) && pMainWindow->getPolygonAction()->isChecked())
-  {
-    // if we are starting to create a polygon then create line object and add to graphicsview
-    createPolygonShape(mapToScene(event->pos()));
-  }
-  // if left button presses and we are starting to create a Text
-  else if ((event->button() == Qt::LeftButton) && pMainWindow->getTextAction()->isChecked())
-  {
-    // if we are starting to create a text then create text object and add to graphicsview
-    createTextShape(mapToScene(event->pos()));
-  }
-  // if left button presses and we are starting to create a BITMAP
-  else if ((event->button() == Qt::LeftButton) && pMainWindow->getBitmapAction()->isChecked())
-  {
-    // if we are starting to create a BITMAP then create BITMAP object and add to graphicsview
-    createBitmapShape(mapToScene(event->pos()));
-  }
   // if left button presses and we are not creating a connector
   else if ((event->button() == Qt::LeftButton))
@@ -712,5 +485,5 @@
     mIsMovingComponents = true;
     // save the position of all components
-    foreach (Component_OMC *pComponent, mComponents_OMCList)
+    foreach (Component *pComponent, mComponentsList)
     {
       pComponent->setOldPosition(pComponent->pos());
@@ -718,11 +491,5 @@
     }
   }
-  /* don't send mouse press events to items if we are creating something, only send them if creating a connector
-       because for connector we need to select end port */
-  if (!mIsCreatingLine and !mIsCreatingPolygon and !mIsCreatingRectangle and !mIsCreatingEllipse
-      and !mIsCreatingText and !mIsCreatingBitmap)
-  {
-    QGraphicsView::mousePressEvent(event);
-  }
+  QGraphicsView::mousePressEvent(event);
 }
 
@@ -733,5 +500,5 @@
     mIsMovingComponents = false;
     // if component position is changed then update annotations
-    foreach (Component_OMC *pComponent, mComponents_OMCList)
+    foreach (Component *pComponent, mComponentsList)
     {
       if (pComponent->getOldPosition() != pComponent->pos())
@@ -739,5 +506,5 @@
         pComponent->updatePlacementAnnotation();
         // if there are any connectors associated to component update their annotations as well.
-        foreach (LineAnnotation_OMC *pConnectionLineAnnotation, mConnectionsList)
+        foreach (LineAnnotation *pConnectionLineAnnotation, mConnectionsList)
         {
           if ((pConnectionLineAnnotation->getStartComponent()->getParentComponent() == pComponent) ||
@@ -759,27 +526,4 @@
 void GraphicsView::mouseDoubleClickEvent(QMouseEvent *event)
 {
-  MainWindow *pMainWindow = mpModelWidget->getModelWidgetContainer()->getMainWindow();
-  if (mIsCreatingLine)
-  {
-    // finish creating the line
-    mIsCreatingLine = false;
-    // add the line to shapes list
-    addShapeObject(mpLineShape);
-    mpLineShape->setFlags(QGraphicsItem::ItemIsMovable | QGraphicsItem::ItemIsSelectable);
-    mpLineShape->drawRectangleCornerItems();
-    // make the toolbar button of line unchecked
-    pMainWindow->getLineAction()->setChecked(false);
-  }
-  else if (mIsCreatingPolygon)
-  {
-    // finish creating the line
-    mIsCreatingPolygon = false;
-    // add the line to shapes list
-    addShapeObject(mpPolygonShape);
-    mpPolygonShape->setFlags(QGraphicsItem::ItemIsMovable | QGraphicsItem::ItemIsSelectable);
-    mpPolygonShape->drawRectangleCornerItems();
-    // make the toolbar button of line unchecked
-    pMainWindow->getPolygonAction()->setChecked(false);
-  }
   QGraphicsView::mouseDoubleClickEvent(event);
 }
@@ -898,47 +642,6 @@
   mpPasteComponentAction->setStatusTip(tr("Copy the item"));
   mpPasteComponentAction->setDisabled(true);
-  connect(mpPasteComponentAction, SIGNAL(triggered()), SLOT(pasteComponent()));
+  //connect(mpPasteComponentAction, SIGNAL(triggered()), SLOT(pasteComponent()));
   //mpPasteComponentAction->setShortcut(QKeySequence("Ctrl+c"));
-}
-
-void GraphicsView::createMenus()
-{
-
-}
-
-//pasting the required copied component or a selection in the present view
-//non functional currently, only works for a single component
-void GraphicsView::pasteComponent()
-{
-
-  QClipboard *clipboard = QApplication::clipboard();
-
-  if(!clipboard->text().isEmpty())
-  {
-    //GraphicsView *pGraphicsView = qobject_cast<GraphicsView*>(const_cast<QObject*>(sender()));
-    Component *oldComponent = getComponentObject(clipboard->text());
-    Component *newComponent;
-    QString name = getUniqueComponentName(oldComponent->getName().toLower());
-
-    //QPointF point;
-    QPointF point (mapToScene(pos()));
-
-    //point= QPointF((pos().x()) +1.0 ,(pos().y()) +1.0);
-    //newComponent = new Component(oldComponent,name,point,oldComponent->getIsConnector(),this);
-    // remove the component from the scene
-    //mpGraphicsView->scene()->removeItem(this);
-    // if the signal is not send by graphicsview then call addclassannotation
-    //if (!pGraphicsView)
-    // {
-    //   if (mpGraphicsView->mIconType == StringHandler::ICON)
-    //     mpGraphicsView->addClassAnnotation();
-    // }
-    // delete(this);
-    //addComponentObject(newComponent);
-  }
-  else
-  {
-    return ;
-  }
 }
 
@@ -947,170 +650,4 @@
   GraphicsViewProperties *pGraphicsViewProperties = new GraphicsViewProperties(this);
   pGraphicsViewProperties->show();
-}
-
-void GraphicsView::createLineShape(QPointF point)
-{
-  if (mpModelWidget->getLibraryTreeNode()->isReadOnly())
-    return;
-
-  if (!mIsCreatingLine)
-  {
-    mIsCreatingLine = true;
-    mpLineShape = new LineAnnotation(this);
-    mpLineShape->addPoint(point);
-    mpLineShape->addPoint(point);
-    scene()->addItem(mpLineShape);
-  }
-  // if we are already creating a line then only add one point.
-  else
-  {
-    mpLineShape->addPoint(point);
-  }
-}
-
-void GraphicsView::createPolygonShape(QPointF point)
-{
-  if (mpModelWidget->getLibraryTreeNode()->isReadOnly())
-    return;
-
-  if (!mIsCreatingPolygon)
-  {
-    mIsCreatingPolygon = true;
-    mpPolygonShape = new PolygonAnnotation(this);
-    mpPolygonShape->addPoint(point);
-    mpPolygonShape->addPoint(point);
-    mpPolygonShape->addPoint(point);
-    scene()->addItem(mpPolygonShape);
-  }
-  // if we are already creating a polygon then only add one point.
-  else
-  {
-    mpPolygonShape->addPoint(point);
-  }
-}
-
-void GraphicsView::createRectangleShape(QPointF point)
-{
-  if (mpModelWidget->getLibraryTreeNode()->isReadOnly())
-    return;
-
-  if (!mIsCreatingRectangle)
-  {
-    mIsCreatingRectangle = true;
-    mpRectangleShape = new RectangleAnnotation(this);
-    mpRectangleShape->addPoint(point);
-    mpRectangleShape->addPoint(point);
-    scene()->addItem(mpRectangleShape);
-  }
-  // if we are already creating a rectangle then simply finish creating it.
-  else
-  {
-    // finish creating the rectangle
-    mIsCreatingRectangle = false;
-    // add the line to shapes list
-    addShapeObject(mpRectangleShape);
-    mpRectangleShape->setFlags(QGraphicsItem::ItemIsMovable | QGraphicsItem::ItemIsSelectable);
-    mpRectangleShape->drawRectangleCornerItems();
-    // make the toolbar button of line unchecked
-    mpModelWidget->getModelWidgetContainer()->getMainWindow()->getRectangleAction()->setChecked(false);
-  }
-}
-
-void GraphicsView::createEllipseShape(QPointF point)
-{
-  if (mpModelWidget->getLibraryTreeNode()->isReadOnly())
-    return;
-
-  if (!mIsCreatingEllipse)
-  {
-    mIsCreatingEllipse = true;
-    mpEllipseShape = new EllipseAnnotation(this);
-    mpEllipseShape->addPoint(point);
-    mpEllipseShape->addPoint(point);
-    scene()->addItem(mpEllipseShape);
-  }
-  // if we are already creating a rectangle then simply finish creating it.
-  else
-  {
-    // finish creating the rectangle
-    mIsCreatingEllipse = false;
-    // add the line to shapes list
-    addShapeObject(mpEllipseShape);
-    mpEllipseShape->setFlags(QGraphicsItem::ItemIsMovable | QGraphicsItem::ItemIsSelectable);
-    mpEllipseShape->drawRectangleCornerItems();
-    // make the toolbar button of line unchecked
-    mpModelWidget->getModelWidgetContainer()->getMainWindow()->getEllipseAction()->setChecked(false);
-  }
-}
-
-void GraphicsView::createTextShape(QPointF point)
-{
-  if (mpModelWidget->getLibraryTreeNode()->isReadOnly())
-    return;
-
-  if (!mIsCreatingText)
-  {
-    mIsCreatingText = true;
-    mpTextShape = new TextAnnotation(this);
-    mpTextShape->addPoint(point);
-    mpTextShape->addPoint(point);
-    scene()->addItem(mpTextShape);
-  }
-  // if we are already creating a text then simply finish creating it.
-  else
-  {
-    // finish creating the text
-    mIsCreatingText = false;
-    // add the line to shapes list
-    addShapeObject(mpTextShape);
-    mpTextShape->setFlags(QGraphicsItem::ItemIsMovable | QGraphicsItem::ItemIsSelectable);
-    mpTextShape->drawRectangleCornerItems();
-    // make the toolbar button of line unchecked
-    mpModelWidget->getModelWidgetContainer()->getMainWindow()->getTextAction()->setChecked(false);
-    // open the text properties dialog
-    mpTextWidget = new TextWidget(mpTextShape, mpModelWidget->getModelWidgetContainer()->getMainWindow());
-    mpTextWidget->show();
-  }
-}
-
-void GraphicsView::createBitmapShape(QPointF point)
-{
-  if (mpModelWidget->getLibraryTreeNode()->isReadOnly())
-    return;
-
-  if (!mIsCreatingBitmap)
-  {
-    //If  model doesnt exist, then alert the user...
-    if(mpModelWidget->getLibraryTreeNode()->getFileName().isEmpty())
-    {
-      QMessageBox *msgBox = new QMessageBox(mpModelWidget->getModelWidgetContainer()->getMainWindow());
-      msgBox->setWindowTitle(QString(Helper::applicationName).append(" - Information"));
-      msgBox->setIcon(QMessageBox::Warning);
-      msgBox->setText(QString("The class needs to be saved before you can insert a bitmap."));
-      msgBox->setStandardButtons(QMessageBox::Ok);
-      msgBox->setDefaultButton(QMessageBox::Ok);
-      msgBox->exec();
-      mpModelWidget->getModelWidgetContainer()->getMainWindow()->getBitmapAction()->setChecked(false);
-      return;
-    }
-    mIsCreatingBitmap = true;
-    mpBitmapShape = new BitmapAnnotation(this);
-    mpBitmapShape->addPoint(point);
-    mpBitmapShape->addPoint(point);
-    scene()->addItem(mpBitmapShape);
-  }
-  else
-  {
-    // finish creating the bitmap
-    mIsCreatingBitmap = false;
-    // add the line to shapes list
-    addShapeObject(mpBitmapShape);
-    mpBitmapShape->setFlags(QGraphicsItem::ItemIsMovable | QGraphicsItem::ItemIsSelectable);
-    mpBitmapShape->drawRectangleCornerItems();
-    // make the toolbar button of line unchecked
-    mpModelWidget->getModelWidgetContainer()->getMainWindow()->getBitmapAction()->setChecked(false);
-    mpBitmapWidget = new BitmapWidget(mpBitmapShape, mpModelWidget->getModelWidgetContainer()->getMainWindow());
-    mpBitmapWidget->show();
-  }
 }
 
@@ -1149,5 +686,5 @@
 }
 
-void GraphicsView::addConnection(Component_OMC *pComponent)
+void GraphicsView::addConnection(Component *pComponent)
 {
   // When clicking the start component
@@ -1155,8 +692,8 @@
   {
     QPointF startPos = pComponent->mapToScene(pComponent->boundingRect().center());
-    mpConnectionLineAnnotation = new LineAnnotation_OMC(pComponent, this);
+    mpConnectionLineAnnotation = new LineAnnotation(pComponent, this);
     setIsCreatingConnection(true);
     // if component is a connector
-    Component_OMC *pRootParentComponent = pComponent->getRootParentComponent();
+    Component *pRootParentComponent = pComponent->getRootParentComponent();
     if (pRootParentComponent)
       pRootParentComponent->addConnectionDetails(mpConnectionLineAnnotation);
@@ -1171,5 +708,5 @@
   {
     mpConnectionLineAnnotation->setEndComponent(pComponent);
-    Component_OMC *pStartComponent = mpConnectionLineAnnotation->getStartComponent();
+    Component *pStartComponent = mpConnectionLineAnnotation->getStartComponent();
     MainWindow *pMainWindow = mpModelWidget->getModelWidgetContainer()->getMainWindow();
     if (pStartComponent == pComponent)
@@ -1180,108 +717,29 @@
       return;
     }
-    QString startComponentName, endComponentName;
+    bool showConnectionArrayDialog = false;
     if (pStartComponent->getParentComponent())
-      startComponentName = QString(pStartComponent->getParentComponent()->getName()).append(".").append(pStartComponent->getComponentInfo()->getName());
-    else
-      startComponentName = pStartComponent->getName();
+      if ((pStartComponent->getComponentInfo()->getArrayIndex().compare("n") == 0) || (pStartComponent->getComponentInfo()->getArrayIndex().compare(":") == 0))
+        showConnectionArrayDialog = true;
     if (pComponent->getParentComponent())
-      endComponentName = QString(pComponent->getParentComponent()->getName()).append(".").append(pComponent->getComponentInfo()->getName());
-    else
-      endComponentName = pComponent->getName();
-    createConnection(startComponentName, endComponentName);
-  }
-}
-
-//! Begins creation of connector or complete creation of connector depending on the mIsCreatingConnector flag.
-//! @param pComponent is a pointer to the clicked Component, either start or end depending on the mIsCreatingConnector flag.
-void GraphicsView::addConnector(Component *pComponent)
-{
-  //When clicking start port
-  if (!mIsCreatingConnection)
-  {
-    QPointF startPos = pComponent->mapToScene(pComponent->boundingRect().center());
-    mpConnector = new Connector(pComponent, this);
-    scene()->addItem(mpConnector);
-    mIsCreatingConnection = true;
-    //if component is a connector
-    if (pComponent->getParentComponent())
-      pComponent->getParentComponent()->addConnector(mpConnector);
-    else
-      pComponent->addConnector(mpConnector);
-    mpConnector->setStartComponent(pComponent);
-    mpConnector->addPoint(startPos);
-    mpConnector->addPoint(startPos);
-    mpConnector->drawConnector();
-  }
-  // When clicking end port
-  else
-  {
-    Component *pStartComponent = mpConnector->getStartComponent();
-    QString startIconName, startIconCompName, endIconName, endIconCompName;
-    if (pStartComponent->getParentComponent())
+      if ((pComponent->getComponentInfo()->getArrayIndex().compare("n") == 0) || (pComponent->getComponentInfo()->getArrayIndex().compare(":") == 0))
+        showConnectionArrayDialog = true;
+    if (showConnectionArrayDialog)
     {
-      startIconName = QString(pStartComponent->getParentComponent()->getName()).append(".");
-      startIconCompName = pStartComponent->getComponentInfo()->getName();
+      ConnectionArray *pConnectionArray = new ConnectionArray(this, mpConnectionLineAnnotation,
+                                                              getModelWidget()->getModelWidgetContainer()->getMainWindow());
+      pConnectionArray->show();
     }
     else
     {
-      startIconCompName = pStartComponent->getName();
-    }
-    if (pComponent->getParentComponent())
-    {
-      endIconName = QString(pComponent->getParentComponent()->getName()).append(".");
-      endIconCompName = pComponent->getComponentInfo()->getName();
-    }
-    else
-    {
-      endIconCompName = pComponent->getName();
-    }
-
-    MainWindow *pMainWindow = mpModelWidget->getModelWidgetContainer()->getMainWindow();
-    QList<ComponentInfo*> startcomponents = pStartComponent->getParentComponent()->getChildComponentInfo();
-    if (startcomponents.isEmpty())
-    {
-      startcomponents = pMainWindow->getOMCProxy()->getComponents(pStartComponent->getParentComponent()->getClassName());
-    }
-    //to check whether the component is an array of connectors
-    foreach(ComponentInfo *pComponentInfo , startcomponents)
-    {
-      //to check whether the component is an array of connectors
-      if (pComponentInfo->getName() == startIconCompName)
-      {
-//        if (pComponentInfo->getIndexValue() != -1)
-//        {
-//          mpConnector->setStartConnectorisArray(true);
-//        }
-      }
-    }
-
-    QList<ComponentInfo*> endcomponents = pComponent->getParentComponent()->getChildComponentInfo();
-    if(endcomponents.isEmpty())
-    {
-      endcomponents = pMainWindow->getOMCProxy()->getComponents(pComponent->getParentComponent()->getClassName());
-    }
-    //to check whether the component is an array of connectors
-    foreach(ComponentInfo *pComponentInfo , endcomponents)
-    {
-      if (pComponentInfo->getName() == endIconCompName)
-      {
-//        if (pComponentInfo->getIndexValue() != -1)
-//        {
-//          mpConnector->setEndConnectorisArray(true);
-//        }
-      }
-    }
-    //if atleast one of the port is an array of connectors
-    if (mpConnector->getEndConnectorisArray() || mpConnector->getStartConnectorisArray())
-    {
-      mpConnector->setEndComponent(pComponent);
-      //shows the connector array menu for adding the index for the array
-      mpConnector->mpConnectorArrayMenu->show();
-    }
-    else
-    {
-      createConnection(pStartComponent, QString(startIconName).append(startIconCompName),
-                       pComponent, QString(endIconName).append(endIconCompName));
+      QString startComponentName, endComponentName;
+      if (pStartComponent->getParentComponent())
+        startComponentName = QString(pStartComponent->getParentComponent()->getName()).append(".").append(pStartComponent->getComponentInfo()->getName());
+      else
+        startComponentName = pStartComponent->getName();
+      if (pComponent->getParentComponent())
+        endComponentName = QString(pComponent->getParentComponent()->getName()).append(".").append(pComponent->getComponentInfo()->getName());
+      else
+        endComponentName = pComponent->getName();
+      createConnection(startComponentName, endComponentName);
     }
   }
@@ -1298,5 +756,7 @@
     {
       setIsCreatingConnection(false);
-      Component_OMC *pEndComponent = mpConnectionLineAnnotation->getEndComponent();
+      mpConnectionLineAnnotation->setStartComponentName(startComponentName);
+      mpConnectionLineAnnotation->setEndComponentName(endComponentName);
+      Component *pEndComponent = mpConnectionLineAnnotation->getEndComponent();
       if (pEndComponent->getParentComponent())
         pEndComponent->getParentComponent()->addConnectionDetails(mpConnectionLineAnnotation);
